package soln;

import java.util.Scanner;

import type.lib.ToolBox;

/**
 * Name: Last Name, First Name
 * 
 * Student Number: xxxxxxxxx
 * 
 * Declaration: I hereby assert that this application was written by me. I
 * understand that it is a violation of the Senate Policy on Academic Honesty
 * for me to submit someone else's work without identifying it as such and that
 * this is a form of cheating. I also understand that if it is discovered that I
 * have committed a breach of Academic Honesty for cheating or any other charge,
 * then the full extent of available penalties may be brought against me.
 * 
 */
public class Check07J {

	public static void main(String[] args) {
		// Step 1a. Print the prompt "Please enter a bank balance in dollars" to
		// the
		// console
		System.out.println("Please enter a bank balance in dollars");

		// Step 1b. Complete the comment block above with your name and student
		// number.

		// Step 1c. declare a variable called input of type Scanner
		Scanner input;

		// Step 1d. Follow the example in Section 2.2.5 about invoking the
		// Scanner constructor in order construct a Scanner object that is
		// connected to the InputStream referenced by System.in.

		input = new Scanner(System.in);

		// Step 1e. Use the variable to represent the what the user has entered.
		// Read what the user has typed using the nextDouble() method
		// of the class Scanner.
		// Assign the return value of this method to a double variable called
		// balance.

		double balance = input.nextDouble();

		// Step 1f. Print the value of variable balance to the console,
		// precede the value with the message "Your current balance is" and
		// follow the value with the suffix " dollars."
		// e.g., if balance=-500, the message should be
		// "Your current balance is -500 dollars."

		System.out.println("You current balance is " + balance + " dollars.");

		// Step 1g. We want the user to be allowed to deposit money to the bank
		// account. Print the prompt
		// "Please enter the amount you would like to deposit in dollars". We
		// now need to get a secondary input from the user that is the deposit
		// amount as a double (Just like we got the balance). Store this input
		// in a new variable called deposit.
		System.out
				.println("Please enter the amount you would like to deposit in dollars");
		double deposit = input.nextDouble();

		// Step 1h. The precondition for a deposit is that it is not a negative
		// number. The relational operators (<, >, <= and >=) can be used in an
		// expression to determine whether the deposit amount is negative by
		// checking if it is less then 0. The number 0 should be stored in a
		// constant called ZERO. Store the result of the relation in a variable
		// of type boolean called isDepositNegative.
		final int ZERO = 0;
		boolean isDepositNegative = deposit < ZERO;

		// Step 1i. If the deposit amount is of negative value then the system
		// should crash and display the message
		// "The deposit value cannot be negative.".
		// Validate the deposit amount
		// using the following:
		// Class ToolBox has a static method called crash with the
		// following API
		// static void crash(boolean, String)
		// If the passed boolean is false, the method returns without doing
		// anything.
		// If the passed boolean is true, it triggers a runtime exception whose
		// message is the passed String parameter.
		// For more details, refer to section 3.2.5 (Page 115 2ed and Page 112
		// 3ed)

		ToolBox.crash(isDepositNegative,
				"The deposit value cannot be negative.");

		// Step 1j. Add the deposit variable to the balance variable to make a
		// new balance. The new balance can be stored in the previous balance
		// variable.

		balance = balance + deposit;

		// Step 1k. Prompt the user with the amount they deposited and their new
		// balance.
		// If the balance was -500 dollars and the user deposited 1000 dollars
		// then the balance should now be 500 dollars. The user would see:
		// " You deposited 1000 dollars. Your new balance is 500 dollars."
		System.out.println("You deposited " + deposit
				+ " dollars. Your new balance is " + balance + " dollars.");

	}
}
