package soln;

import helper.Helper;

import javax.swing.*;


public class Check07R {

	public static void main(String[] args) {
		// Step 3a. This time we want to use a dialog to prompt the user. The
		// JOptionPane utility class has a static method:
		// public String showInputDialog(String message)
		// Use the method to ask the user to "Please enter the current year".
		// store the result in a new variable called dialogInput
		// For more details, refer to section 3.3.3 (Page 123 2ed and Page 120
		// 3ed)
		String dialogInput = JOptionPane
				.showInputDialog("Please enter the current year");

		// Step 3b. The class Integer has a static method for converting strings
		// into values of type int:
		// public static int parseInt(String input);
		// Use the method to convert the dialogInput String into a int.
		// Store the result in the variable currentYear
		// For more details, refer to Page 123 2ed and Page 120 3ed
		int currentYear = Integer.parseInt(dialogInput);

		// Step 3c. Prompt the user with the a message stating the current year.
		// Again we want to use a dialog to prompt the user. The JOptionPane
		// utility class has a static method:
		// public String showMessageDialog(String message)
		// For more details, refer to section 3.3.3 (Page 123 2ed and Page 120
		// 3ed)
		// Print the value of variable balance to the console,
		// precede the value with the message "The current year is " and follow
		// the value with the suffix "."
		// e.g., If the year is 2010 then the the message should be
		// "The current year is 2010."
		JOptionPane.showMessageDialog(null, "The current year is "
				+ currentYear + ".");

		// Step 3d. We want to know what year the user was born. This time we want to use a dialog to prompt the user. Use the
		// showInputDialog(String message) method from the JOptionPane class
		// like you did in Step 3a. Store the result in the same variable as last time.
		dialogInput = JOptionPane.showInputDialog("Enter your year of birth:");

		// Step 3e. Use the parseInt(String input) to convert the new user input an int. Store it in the variable yearOfBirth.
		// For more details, refer to Page 123 2ed and Page 120 3ed
		int yearOfBirth = Integer.parseInt(dialogInput);

		// Step 3f. Repeat Step. 1h from Check07P.
		boolean isYearOfBirthImpossible = yearOfBirth > currentYear;

		// Step 3g. If the year of birth is after the current year then the
		// system
		// should crash and display the message
		// "The year of birth cannot be more then the current year.". 
		// The class Helper has the following static method:
		// static void crashDialog(boolean condition, String method)
		// This method provides
		// This method provides this service.
		Helper.crashDialog(isYearOfBirthImpossible, "The year of birth cannot be more then the current year.");

		// Step 3h. Repeat Step. 1j from Check07P.
		int userAge = currentYear - yearOfBirth;

		// Step 3i.  Prompt the user with their age. See step 3c.
		// if the user was born in 1991 and the current year is 2010 then the message should be "You are 19 years old".
		JOptionPane
				.showMessageDialog(null, "You are " + userAge + " years old");
	}
}
